      SUBROUTINE CVRTOP(X, Y, R, THETA)
C
C-------- BRUCE JULIAN
C
C-------- CVRTOP - CONVERT FROM RECTANGULAR TO POLAR COORDINATES
C
C (OUTPUT - MAY OVERLAY X, Y)
C
C-------- STANDARD FORTRAN FUNCT. REQUIRED:  ATAN2
C-------- FUNCT. REQUIRED:  HYPOT
C
      R = HYPOT(X, Y)
      THETA = 0.
      IF ((Y .NE. 0.) .OR. (X .NE. 0.)) THETA = ATAN2(Y, X)
      RETURN
      END

      REAL FUNCTION HYPOT(A, B)
C
C-------- BRUCE JULIAN
C
C
C-------- HYPOT - CALCULATES EUCLIDIAN DISTANCE, ACCURATELY AND
C            AVOIDS OVERFLOW
C
      REAL A, B
      REAL ABS, L, S, T, SQRT
      L = ABS(A)
      S = ABS(B)
      IF (S .LE. L) GOTO 1
         T = S
         S = L
         L = T
   1  IF (L .NE. 0.0) GOTO 2
         HYPOT = 0.0
         RETURN
   2  S = S/L
      HYPOT = L*SQRT(S*S+1.0)
      RETURN
      END

