C*******************************************************************
C
C   SUBROUTINE TO CALCULATE THE DIRECT PATH HORIZONTAL DISPLACEMENT FOR AN
C   N-LAYERED ONE-DIMENSIONAL MODEL
C
C      BARRY R. LIENERT    OCTOBER, 1982
C      MODIFIED FOR VARIABLE ELEVATION STATIONS 2/17/87
C
C   INPUTS:   P       RAYPATH PARAMETER = SIN(THETA)/VELOCITY
C             ETA     DEPTH TO EVENT FROM THE TOP OF THE LAYER
C                     IT IS IN
C             N       LAYER EVENT IS IN
C             ETA1    DEPTH TO STATION FROM TOP OF THE LAYER
C                     IT IS IN
C             N1      LAYER STATION IS IN     
C             NN      NO OF PARAMETERS
C             PARM(I) I=1,NN   LAYER VELOCITIES, THEN THICKNESSES
C
C*******************************************************************
      DOUBLE PRECISION FUNCTION DEL(P,ETA,N,ETA1,N1,NN,PARM)
      DIMENSION PARM(1)
      DOUBLE PRECISION E,P
      NL=(NN+1)/2
      DEL=0.0D0
      NA=N1
      EA=PARM(NL+N1)-ETA1
      NB=N
      EB=ETA
      IF(NB.GE.NA)GO TO 5
      NA=N
      EA=PARM(NL+N)-ETA
      NB=N1
      EB=ETA1
5     CONTINUE
      DO 10 I=NA,NB
      E=DBLE(PARM(NL+I))
      IF(I.EQ.NA)E=DBLE(EA)
      IF(I.EQ.NB)E=DBLE(EB)
      IF(DBLE(PARM(I))*P.GE.1.0D0)GO TO 11
10    DEL=DEL+E/DSQRT(1.0D0/(DBLE(PARM(I))*P)**2-1.0D0)
      RETURN
11    DEL=1000.
      WRITE(6,100)I
100   FORMAT(1X,/,'   **** ERROR IN DEL - P GE 1/V(',I2,') ****')
      RETURN
      END