c
c Program to model the error of hypocenter determination
c Jure Ravnik in Mladen Zivcic
c July 1997
c Avgust 2000
c November 2000
c Januar 2001
c June 2001

      REAL parmS(100),parmP(100), x(3), x0(3),dx(3), 
     +tmin, delta, aninc, dtdx,dtdy,dtdz,
     +ploscina,nedepi,nicnic,tplus,enproc,kajsort,max  
      REAL lambP(100),fiP(100), visP(100), Odvodi(100,4), ata(4,4)
     +,sigtP(100),sigtS(100),sigparmP(100),sigparmS(100), ataS(4,4)
     +,li,iata(4,4),d,deltaX(100),indXx(100),nnx,nx
     + ,gampX(100), tampX(100), distX(100)
     + ,gampXx(100), tampXx(100), distXx(100)
      CHARACTER*4 imeP(100),imeX(100),imexx(100), imeXxx(100), imeS(100)
      REAL az0,ulo(2),ulo0(2)
      INTEGER cel(2),cel0(2),ii,jj,indx(4),iflag
      INTEGER nn,stposP,stposS,flagP(100),flagS(100),moho,
     +flagPxx(100),flagSxx(100),flagPxxx(100),flagSxxx(100)
      CHARACTER*1 ns,ew,lambCP(100),fiCP(100) 
      
      CHARACTER*40 imemod,imepos, imerez, imerezPS, imekont, imeproj        
      CHARACTER*4 alimoho 
      
      REAL lambX(100),fiX(100),visX(100),sigtPX(100)
     +,sigtSX(100)
      CHARACTER*1 lambCX(100),fiCX(100) 
      
      REAL lambXx(100),fiXx(100),visXx(100),sigtPXx(100)
     +,sigtSXx(100)
      CHARACTER*1 lambCXx(100),fiCXx(100)
      
      REAL lambXxx(100),fiXxx(100),visXxx(100),sigtPXxx(100)
     +,sigtSXxx(100)
      CHARACTER*1 lambCXxx(100),fiCXxx(100) 
      
      
      REAL lambS(100),fiS(100),visS(100)
     
      CHARACTER*1 lambCS(100),fiCS(100)    
      CHARACTER*2 ksort
c deklaracije za jacobi
      REAL jacA(3,3),jacNEDEPI, jacNEDZAR
      REAL jacLV1,jacLV2,jacLV3
c deklaracije za elipso z=0
      REAL eliPL,eliNEDEPI
c deklaracije za nedolocenost osi
      REAL nedX,nedY,nedZ
      INTEGER prp,kaj
   
c     deklaracije za selekcijo postaj
      REAL povecavaX(100), sumX(100)  
      REAL povecavaXx(100), sumXx(100)  
      REAL povecavaXxx(100), sumXxx(100)
      REAL povecavaP(100), sumP(100)
      REAL povecavaS(100), sumS(100)
      REAL staltaN, zapisminN, rmwa, rml
      CHARACTER*1 tip(100)
      REAL stalta(100), zapismin(100)
      REAL deltakm, deldeg, rdist, perioda, ampwa, atml, amp, gain
      REAL frek0, ampmm
      REAL fimin, fimax, fistep, lamin, lamax, lastep, globina
      INTEGER minopaz, nsirin, ndolzin, dolime
      CHARACTER kaksnaat*2, triger*2
      
c constants      
      pi=3.14159265d0
      degtorad=pi/180.0         
      iflag=1

c Print the logo and get the project name
      Print *,'Welcome to LOK'
      Print *,'By JR & MZ in 1999,2000 & 2001'
      Print *,' '
      Print *,'Enter project name :'
      Read (*,'(A)') imeproj
c      imeproj='test'
      
      dolime=len_trim(imeproj)
      imemod=imeproj(1:dolime)//'.mdl'
      imepos=imeproj(1:dolime)//'.sts'
      imekont=imeproj(1:dolime)//'.prm'
      imerez=imeproj(1:dolime)//'.p'
      imerezPS=imeproj(1:dolime)//'.sp'

c Read model parameters:
c  hitP   - P wave velocity, 
c  hitS   - S wave velocity, 
c  glob   - depth to top of layer (=0 for the topmost layer), 
c  kjeMOHO- flag to indicate the first mantle layer, 
c  sigVP  - error of P velocity estimate for the layer,
c  sigVS  - error estimate for S wave velocity in the layer,
c  sigG   - error estimat of the layer thickness
c     WARNING:	layer boundaries with +/- sigG should not
c              overlap (no sigG can be larger then 
c              thickness of adjacent layers)
c
      PRINT *,'Reading velocity model in : ',imemod
      OPEN (UNIT=11, FILE=imemod,status='old') 
      READ(11,*) parmP(1), parmS(1), nicnic, sigparmP(1)
     +,sigparmS(1),nicnic,alimoho
      if (alimoho .EQ. 'MOHO') moho=1                
      i=2
5     READ(11,*,end=10) parmP(i),parmS(i),parmP(50+i),
     +sigparmP(i),sigparmS(i),sigparmP(50+i),alimoho
     

c move thicknesses to indeces above 50 for P and S     
      if (alimoho .EQ. 'MOHO') moho=i      
      parmS(50+i)=parmP(50+i)
      sigparmS(50+i)=sigparmP(50+i)
     
      i=i+1
      go to 5

10    CLOSE(11)
      nn=2*(i-1)-1 
      parmP(51)=0
      parmS(51)=0
      do 12 j=i,nn        
      SigparmP(j)=SigparmP(50+j-i+2)
      SigparmS(j)=SigparmS(50+j-i+2)
      parmP(j)=parmP(50+j-i+2)-parmP(50+j-i+1) 
12    parmS(j)=parmS(50+j-i+2)-parmS(50+j-i+1)     
c End of model input          
      
c Print the model
      print *,'Vp+-SigVp  Vs+-SigVs Debelina+-SigG  Moho'
      if (1 .EQ. moho) then 
      alimoho='MOHO'
      ELSE 
      alimoho=' '
      END IF
      nicnic=0.0
      WRITE (*,11) parmP(1),'+-',sigparmP(1),parmS(1),'+-',sigparmS(1)
     +,nicnic,'+-',nicnic,alimoho 
11    FORMAT (F4.1,A2,F4.1,F6.1,A2,F4.1,F6.1,A2,F4.1,A7)  
      
      DO 14 i=2,(nn+1)/2                               
      if (i .EQ. moho) then 
      alimoho='MOHO'
      ELSE 
      alimoho=' '
      END IF
      WRITE (*,13) parmP(i),'+-',sigparmP(i),parmS(i),'+-',sigparmS(i)
     +,parmP((nn+1)/2+i-1),'+-',sigparmP((nn+1)/2+i-1),alimoho 
13    FORMAT (F4.1,A2,F4.1,F6.1,A2,F4.1,F6.1,A2,F4.1,A7)                                             
14    CONTINUE                   
      
          
c Read station list:
c name
c latutude
c latitude hemisphere
c longitude
c longitude hemisphere
c elevation
c type of station
c flag to use P arrival time
c flag to use S arrival time
c accuracy of P arrival time readings
c accuracy of S arrival time readings
c amplification
c noise level
c STA/LTA ratio to trigger
c minimal amplitude to detect the earthquake
c      ime,46,N,15,E,visina(km),flag,sigmaP(+-0.xx sekund,sigmaS)
      PRINT *,'Reading station data in : ', imepos
      OPEN (UNIT=11, FILE=imepos,status='old')
      i=0
15    i=i+1
      READ(11,*,end=20) imeX(i),lambX(i),lambCX(i),fiX(i),fiCX(i)
     +,visX(i),tip(i),flagP(i),flagS(i),sigtPX(i),sigtSX(i)
     +,povecavaX(i),sumX(i),stalta(i), zapismin(i)
      go to 15
20    CLOSE(11)
      stposX=i-1
c End of station data input     

c Convert station co-ordinates to geocentric
      do 30 i=1,stposX
      call celulo(cel0(1),ulo0(1),lambX(i))
      call celulo(cel0(2),ulo0(2),fiX(i))
      call FOLD(rlat,rlon,cel0(1),lambCX(i),ulo0(1),cel0(2)
     +,fiCX(i),ulo0(2))
      lambX(i)=rlon
30    fiX(i)=rlat       

      
c
c Read control parameters:
c	latitude range: from, to, step
c	longitude range: from, to, step
c	hypocentral depth
c	trigger ('SL' or 'MA'), for STA/LTA or minimal trace amplitud 
c	minimal number of stations to trigger
c	attenuation('WA' ali 'ML') for Wood-Anderson or local magnitude
c	rm1, rm2, rm3 coeficients for 'ML'
c
c	   sproti kontroliramo pravilnost upisa in se ustavimo ce je narobe

  
      PRINT *,'Reading control parameter file :', imekont
      open(11,file=imekont, STATUS='OLD')
      read(11,*) fimin, fimax, fistep
      read(11,*) lamin, lamax, lastep
      read(11,*) globina
      read(11,*) triger
      read(11,*) staltaN, zapisminN
      read(11,*) minopaz
      read(11,*) kaksnaat
      read(11,*) rmwa, rml
c      if(kaksnaat.eq.'ML') read(11,*) rm1, rm2, rm3
      read(11,*) rm1, rm2, rm3
      read(11,*) ksort
      read(11,*) nx
      CLOSE (11)   
c Printout of stations      
      do 811 im=1,stposX
c	 print *, stposX, im, stalta(im), zapismin(im)
	 if(stalta(im).lt.1.) stalta(im)=staltaN
	 if(zapismin(im).lt.1.) zapismin(im)=zapisminN
       WRITE(*,7124) im,imeX(im),tip(im),stalta(im), zapismin(im),
     # sumX(im), povecavaX(im)
7124   FORMAT (i3,1X,A4,1x,A1,4f12.2)
 811  continue
  
c Open output file for P modelling      
      PRINT *,'Opening P results file : ', imerez
      OPEN (UNIT=11, FILE=imerez) 
    
c Open output file for P and S modelling       
      PRINT *,'Opening P and S results file : ', imerezPS
      OPEN (UNIT=12, FILE=imerezPS) 

c     Select hypocentral location and convert to geocentric
c     fimin, fimax and fistep define latitude grid
c     lamin, lamax and lastep define longitude grid
c
      nsirin=INT((fimax-fimin)/fistep)+1
      ndolzin=INT((lamax-lamin)/lastep)+1 

      
C
C     Start of the major loop over the grid of hypocentral positions 
C
      
      DO 66 aa=0,nsirin
      DO 66 bb=0,ndolzin
      
      xx1=fimin+aa*fistep
      xx2=lamin+bb*lastep
      xx3=globina
      
         
      ns=lambCS(i)
      lambcs(i)='N'
      ew=fiCS(i)
      ficS(i)='E' 
      call celulo(cel(1),ulo(1),xx1)
      call celulo(cel(2),ulo(2),xx2)
      call FOLD(rlat,rlon,cel(1),lambCS(i),ulo(1),cel(2)
     +,fiCS(i),ulo(2))     

      lambCS(i)=ns
      ficS(i)=ew      
            
c      call FOLD(rlat,rlon,cel(1),ns,ulo(1),cel(2),ew,ulo(2))
      x(1)=rlon
      x(2)=rlat
      x(3)=xx3
c  x(1),x(2) in x(3) are geocentric hypocentral co-ordinates   
c  
      
c ******* Select  the staions to be used in modelling *******
c in this part we determin which stations will record (trigger)
c  on particular event and contribute P and S arrival time data 
c   for hypocenter determination
  
      stposP=0
      stposS=0
      ii=0


C
C     Start of loop over all stations
C
      do 21 i=1,stposX
      
    
      x0(1)=lambX(i)
      x0(2)=fiX(i)
      x0(3)=visX(i)

c     compute epicentral and hypocentral distances
c	  
      call delaz(x0(2),x0(1),delta,dedeg,az0,x(2),x(1))
      deltakm=abs(delta)
      deldeg=abs(dedeg)
      rdist=sqrt(deltakm**2+(x(3)-x0(3))**2)


c
c     Criteria for station selection:
c	-  STA/LTA ratio for digital station with noise level
c	-  minimal trace amplitude for analogue stations with gain
c
c	attenuation is modelled through magntude formula:
c	  -  WA magnitude with logA for Southern California (after Richter)
c	  -  local magnitud	Ml= rm1*log(A/T)+ rm2*log(delta) + rm3
c		 rm1,rm2 and rm3 are input parameters (network dependent)
c		 T is distance and magnitude dependent (not modelled)
c		    gain is also period (T) dependent
c

c      ground amplitude from Mwa attenuation (in mikrometers?)
      ampwa=rmwa-exp(0.280637*alog(deltakm)-0.196834)+3
      ampwa=10.**ampwa/2800.
c       amplitude from ML relation
c	  it can be improved by introducing
c	       period=f(delta,M)
c

      perioda=1.
      atml=0.0
      if(kaksnaat.eq.'ML') then
	 atml=rml-rm2*log10(deldeg)-rm3
	 atml=perioda*10.**atml/rm1
      endif
c	actually used value is defined in parameter file:
      if(kaksnaat.eq.'WA') amp=ampwa
      if(kaksnaat.eq.'ML') amp=atml

c
c     for broadband sensors the amplification is approximately constant
c        over wide range of periods so we use 1Hz value
      gain=povecavaX(i)
c
c     for short period 1hz seismometers and damping of 0.7*critical 
c     
c	eigenfrequency frek0 can be input parameter for each station?!
c
      frek0=1.
      gain=povecavaX(i)*sqrt(1./frek0*frek0+1.)/
     # sqrt(1./(perioda*perioda*frek0*frek0)+1)
c      amplituda zapisa v mm je:
      ampmm=gain*amp*1.E-3
c       WRITE(*,7123) i,imeX(i),triger,kaksnaat, stalta(i), zapismin(i),
c     # delta, sumX(i), povecavaX(i), ampwa, atml, ampmm
c7123   FORMAT (1X,i2,A4,1x,A2,1x,A2,2F5.1,2F7.1,4g10.2)

c	test whether the station records the event
c	  STA/LTA case for digital stations
cad	if(triger.eq.'SL'.and.sumX(i)/1000..gt.amp/stalta(i)) goto 21


      if(tip(i).eq.'D'.and.sumX(i)/1000..gt.amp/stalta(i)) goto 21


c	 amplification case for analogue stations
cad	if(triger.eq.'MA'.and.zapismin(i).gt.ampmm) goto 21


      if(tip(i).eq.'A'.and.zapismin(i).gt.ampmm) goto 21

c ******* this part only for stations that record the event !!!! **********
c     increase the counter of used stations

      ii=ii+1
                 
      if (ksort .EQ. 'ns') kajsort=1/(deltakm+0.00001)                      
      if (ksort .EQ. 'ga') kajsort=amp
      if (ksort .EQ. 'ta') kajsort=ampmm                      
c deltaX - criteria for stations sort (up to nx)            
      DeltaX(ii)=kajsort
      distX(ii)=1./(deltakm+0.00001)
      gampX(ii)=1./amp
      tampX(ii)=1./ampmm
c copy station parameters      
      imeXx(ii)=imeX(i)
      lambXx(ii)=lambX(i)
      lambCXx(ii)=lambCX(i)
      fiXx(ii)=fiX(i)
      fiCXx(ii)=fiCX(i)
      visXx(ii)=visX(i)
      sigtPXx(ii)=sigtPX(i)     
      sigtSXx(ii)=sigtSX(i)
      flagPXx(ii)=flagP(i)     
      flagSXx(ii)=flagS(i)
      povecavaXx(ii)=povecavaX(i)
      sumXx(ii)=sumX(i) 

c end of station loop      
21    CONTINUE

      
c number of contributing stations      
      stposXx=ii
 

      
c *** SORT ***            
c Closes nx stations (largest deltaX)
c nx is read from file               

c there can be less than nx stations      
      if (nx .GT. stposXx) then 
         nnx=stposXx
      else 
         nnx=nx    
      end if
      
c sort       
      do 510,j=1,stposXx
      max=0
      do 500,i=1,stposXx
      if (deltaX(i) .GT. max) then
      indXx(j)=i
      max=deltaX(i)
      end if
500   CONTINUE
510   deltaX(indXx(j))=-1      
            
c copy by index
      do 520,i=1,nnx
      imeXxx(i)=imeXx(indXx(i))
      lambXxx(i)=lambXx(indXx(i))
      lambCXxx(i)=lambCXx(indXx(i))
      fiXxx(i)=fiXx(indXx(i))
      fiCXxx(i)=fiCXx(indXx(i))
      visXxx(i)=visXx(indXx(i))
      sigtPXxx(i)=sigtPXx(indXx(i))   
      sigtSXxx(i)=sigtSXx(indXx(i))  
      flagPXxx(i)=flagPXx(indXx(i))   
      flagSXxx(i)=flagSXx(indXx(i))
      distXx(i)=distX(indXx(i))
      gampXx(i)=gampX(indXx(i))
      tampXx(i)=tampX(indXx(i))
      povecavaXxx(i)=povecavaXx(indXx(i))
520   sumXxx(i)=sumXx(indXx(i)) 

      
      stposXxx=nnx       
      
      
c End of station selection
c All the data we need are in Xxx             
c *** KONEC SORT ***
      
         
c we distinguish between 'P only' and 'P and S' case      
      do 921,i=1,stposXxx                      
c ** P **
      if (flagPXxx(i) .NE. 1) goto 22
      
      stposP=stposP+1      
      
      imeP(stposP)=imeXxx(i)
      lambP(stposP)=lambXxx(i)
      lambCP(stposP)=lambCXxx(i)
      fiP(stposP)=fiXxx(i)
      fiCP(stposP)=fiCXxx(i)
      visP(stposP)=visXxx(i)
      sigtP(stposP)=sigtPXxx(i)
      povecavaP(stposP)=povecavaXxx(i)
      sumP(stposP)=sumXxx(i) 

22    CONTINUE

c ** S **            
      if (flagSXxx(i) .NE. 1) goto 921
      stposS=stposS+1       
      
      imeS(stposS)=imeXxx(i)
      lambS(stposS)=lambXxx(i)
      lambCS(stposS)=lambCXxx(i)
      fiS(stposS)=fiXxx(i)
      fiCS(stposS)=fiCXxx(i)
      visS(stposS)=visXxx(i)
      sigtS(stposS)=sigtSXxx(i)  
      povecavaS(stposS)=povecavaXxx(i)
      sumS(stposS)=sumXxx(i)
      
  
921   CONTINUE


c      goto 555      
c Izpis postaj S
c      Print *,'POSTAJE S'
c      Print *,'Ime Lambda   Fi  Visina NapakaS'
c      Do 122 i=1,stposS
c      Write (*,123) imeS(i),lambS(i),lambCS(i),fiS(i),fiCS(i),visS(i)
c     +,sigtS(i)
c123   FORMAT (1X,A4,F10.6,A1,F12.6,A1,F7.4,F7.4,F7.4)
c122	 CONTINUE
c      pause
   
c ******* KONEC LOCITVE POSTAJ ******
555   CONTINUE 
      
c ****** P ********
            
c P stations loop
      do 40 i=1,stposP
      
      x0(1)=lambP(i)
      x0(2)=fiP(i)
      x0(3)=-visP(i)
   
c compute the derivatives
      call dtdx2(nn,parmP,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)
      dtdx=dx(1)*degtorad/111.19
      dtdy=dx(2)*degtorad/111.19
      dtdz=dx(3)*degtorad/111.19
    
      
c compute weights
c vary velocities nad depths to get derivatives      
      li=sigtP(i)**2     
      DO 33 j=1,nn     
      enproc=0.01*parmP(j)
      parmP(j)=parmP(j)+enproc
      call dtdx2(nn,parmP,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)   
      tplus=tmin
      parmP(j)=parmP(j)-2*enproc
      call dtdx2(nn,parmP,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)
      parmP(j)=parmP(j)+enproc
c      print *,(((tplus-tmin)/(2*enproc))**2)*(sigparmP(i)**2),
c     +tplus, tmin,((tplus-tmin)**2) 
    
33    li=li+(((tplus-tmin)/(2*enproc))**2)*(sigparmP(j)**2)
    

c   
      
c Matrix      
      Odvodi(i,1)=1/Sqrt(li)
      Odvodi(i,2)=dtdx/Sqrt(li)
      Odvodi(i,3)=dtdy/Sqrt(li)
      Odvodi(i,4)=dtdz/Sqrt(li)
      
c      Print *,imeP(i),Odvodi(i,4),Odvodi(i,4)**2

40    Continue 

c Check if we have enough stations      
      if (stposP .LT. 4.or.stposXx.lt.minopaz) then
        prp=-1
      goto 52
      endif           
c We have enough stations
      prp=1
          
c Set ATA to zero in iata to identity          
      do 45 i=1,4
      do 44 j=1,4
      iata(i,j)=0
44    ata(i,j)=0 
45    iata(i,i)=1
             
c Compute ATA
      do 50 i=1,4
      do 50 j=i,4
      do 49 k=1,stposP
49    ata(i,j)=ata(i,j)+odvodi(k,i)*odvodi(k,j)
50    ata(j,i)=ata(i,j)
c End of ATA computation
                               
                         
       
c Invert
     
      Call Ludcmp(ata,4,4,indx,d) 
      do 51 j=1,4
51    call lubksb(ata,4,4,indx,iata(1,j))                  
      
c end of inversion


c Compute eigenvectors and eigenvalues
c After NR Chapter 11.1
c Najprej prepisem vrednosti iz ataS v jacA
      do 360 i=1,3
        do 361 j=1,3
361       jacA(i,j)=iata(i+1,j+1)
360     continue

c klicem rutino za izracun ploscine in nedepi elipse z=0
      call Elipsa(jacA,eliNEDEPI,eliPL)
c klicem rutino, ki klice jacobi in izracuna nedepi in nedzar
      call lvlvek(jacA,jacNEDEPI,jacNEDZAR,jacLV1,jacLV2,jacLV3)

c Izpis
52    Continue  
      call Izpis(prp,xx1,xx2,stposP,jacLV1,jacLV2,jacLV3,eliNEDEPI,
     +jacNEDEPI,jacNEDZAR)
   
   
c ****** add S ********           
      if (stposP .LT. 3 .OR. stposS+stposP .LT. 5
     # .or.stposXx.lt.minopaz) then
      prp=-2
      goto 252
      endif      
c Have enough stations, go on and calculate
      prp=2
      
c  S stations loop
      do 240 jj=1,stposS
      i=jj+stposP
c ta iii mora biti stposp
      
      x0(1)=lambS(jj)
      x0(2)=fiS(jj)
      x0(3)=-visS(jj)
      
 
c Comput derivatives      
      call dtdx2(nn,parmS,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)     
      dtdx=dx(1)*degtorad/111.19
      dtdy=dx(2)*degtorad/111.19
      dtdz=dx(3)*degtorad/111.19

      
c Compute weights
      li=sigtS(jj)**2     
c      Print *,li
      DO 233 j=1,nn
      enproc=0.01*parmS(j)
      parmS(j)=parmS(j)+enproc
      call dtdx2(nn,parmS,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)   
      tplus=tmin
      parmS(j)=parmS(j)-2*enproc
      call dtdx2(nn,parmS,x,x0,' ',moho,0,tmin,dx,delta,aninc,az0,iflag)
      parmS(j)=parmS(j)+enproc

c      print *,(((tplus-tmin)/(2*enproc))**2)*(sigparmS(i)**2),
c     +tplus, tmin,((tplus-tmin)**2) 

233   li=li+(((tplus-tmin)/(2*enproc))**2)*(sigparmS(j)**2)
      
c      print *,'S',li 
c      pause 
c      li=1 

c Matrix      
      Odvodi(i,1)=1/Sqrt(li)
      Odvodi(i,2)=dtdx/Sqrt(li)
      Odvodi(i,3)=dtdy/Sqrt(li)
      Odvodi(i,4)=dtdz/Sqrt(li)
c      Print *,i,li,Odvodi(i,1),Odvodi(i,2), Odvodi(i,3), Odvodi(i,4)
240   Continue      
      
      
c Set ATA to zero and iata to identity          
      do 245 i=1,4
      do 244 j=1,4
      ataS(i,j)=0
244   ata(i,j)=0 
245   ataS(i,i)=1      
          
             
c Compute ATA
      do 250 i=1,4
      do 250 j=i,4
      do 249 k=1,stposS+stposP
249   ata(i,j)=ata(i,j)+odvodi(k,i)*odvodi(k,j)
250   ata(j,i)=ata(i,j)
c End of ATA computation                            

      
c Invert
      Call Ludcmp(ata,4,4,indx,d)
      do 251 j=1,4
251   call lubksb(ata,4,4,indx,ataS(1,j))
c end of inversion


c Compute eigenvectors and eigenvalues
c After NR Chapter 11.1
c Najprej prepisem vrednosti iz ataS v jacA
      do 260 i=1,3
        do 261 j=1,3
261       jacA(i,j)=ataS(i+1,j+1)
260     continue

c subroutine call to get area and nedepi
      call Elipsa(jacA,eliNEDEPI,eliPL)
c subroutine call to call jacobi and computes nedepi and nedzar
      call lvlvek(jacA,jacNEDEPI,jacNEDZAR,jacLV1,jacLV2,jacLV3)

c Izpis
252   call Izpis(prp,xx1,xx2,stposP+stposS,jacLV1,jacLV2,jacLV3,
     &eliNEDEPI,jacNEDEPI,jacNEDZAR)  
 

      PRINT *,'*** Grid point #:',aa*(ndolzin+1)+bb+1,'/',
     &  (nsirin+1)*(ndolzin+1)

66    CONTINUE
 
      ENDFILE 12       
      ENDFILE 11
      PRINT *,'Done.' 
c End of program
      end

c Subroutines         

c Split decimal latitude and longitude to degrees and minutes
      SUBROUTINE CelUlo (cel11,ulo11,x11)
      REAL x11,ulo11
      INTEGER cel11
      cel11 = Aint(x11)  
      ulo11 = (x11-cel11)*60
      END

c Compute alrger semiaxis z=0 and its area
      SUBROUTINE Elipsa(mat,ned,plo)
      REAL mat(3,3),ned,plo
      plo=Pi*(mat(1,1)*mat(2,2)+mat(1,2)*mat(1,2))
      ned=Sqrt(0.5*(mat(1,1)+mat(2,2)+Sqrt((mat(1,1)-mat(2,2))**2
     ++4*(mat(1,2))**2)))
      END

